Index: roard/streams.c
===================================================================
--- roard/streams.c	(revision 6052)
+++ roard/streams.c	(revision 0)
@@ -1,134 +1,8 @@
 //streams.c:
 
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
-
 #include "roard.h"
-
-// declared 'extern'
-struct roar_stream_server * g_streams[ROAR_STREAMS_MAX];
-
-#define _CHECK_SID_RET(id,ret) if ( (id) < 0 || (id) > ROAR_STREAMS_MAX || g_streams[(id)] == NULL ) return (ret)
-#define _CHECK_SID(id)         _CHECK_SID_RET((id), -1)
-
-static int streams_thru_num     =  0;
-static int streams_sync_num     =  0;
-int streams_recsource_id = -1;
-
-static const struct rolestack * streams_rolestack = NULL;
-static int streams_role_num     =  0;
-
-
-static void _streams_change_state(struct roar_stream_server * s, const int new, const char * func) {
- register int id  = ROAR_STREAM(s)->id;
- register int old = s->state;
-
- s->state = new;
-
- if ( func == NULL ) {
-  func = "(unknown)";
- }
-
- ROAR_INFO("_streams_change_state[by %s](id=%i): stream state: %s->%s", ROAR_DBG_INFO_VERBOSE,
-            func,
-            ROAR_STREAM(s)->id,
-            roar_streamstate2str(old), roar_streamstate2str(new));
-
- roar_notify_core_emit_simple(ROAR_OE_BASICS_CHANGE_STATE, -1, id, ROAR_OT_STREAM, old, new, NULL, 0);
-}
-
-void streams_change_sync_num(int id, int diff) {
- struct roar_stream_server * ss;
- int i;
-
- if ( diff != 0 )
-  if ( streams_get_dir(id) != ROAR_DIR_OUTPUT )
-   return;
-
- ROAR_INFO("streams_change_sync_num(id=%i, diff=%i): Number of sync streams changed from %i to %i",
-           ROAR_DBG_INFO_VERBOSE,
-           id, diff,
-           streams_sync_num, streams_sync_num + diff);
- streams_sync_num += diff;
-
- if ( !streams_sync_num && alive ) {
-  ROAR_INFO("streams_change_sync_num(id=%i, diff=%i): Number of sync streams changed to zero. Bad.",
-            ROAR_DBG_INFO_VERBOSE, id, diff
-            );
-
-  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-   if ( (ss = g_streams[i]) == NULL )
-    continue;
-
-   if ( ROAR_STREAM(ss)->dir != ROAR_DIR_OUTPUT )
-    continue;
-
-   if ( !ss->ready )
-    continue;
-
-   if ( ss->state == ROAR_STREAMSTATE_CLOSING )
-    continue;
-
-   if ( streams_get_flag(i, ROAR_FLAG_PRIMARY) ) {
-    ROAR_DBG("streams_change_sync_num(*): try to set sync on primary stream %i", i);
-    streams_set_flag(i, ROAR_FLAG_SYNC);
-    if ( streams_sync_num )
-     return;
-   }
-  }
-
-  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-   if ( (ss = g_streams[i]) == NULL )
-    continue;
-
-   if ( ROAR_STREAM(ss)->dir != ROAR_DIR_OUTPUT )
-    continue;
-
-   if ( !ss->ready )
-    continue;
-
-   if ( ss->state == ROAR_STREAMSTATE_CLOSING )
-    continue;
-
-   if ( !streams_get_flag(i, ROAR_FLAG_PRIMARY) ) {
-    ROAR_DBG("streams_change_sync_num(*): try to set sync on non-primary stream %i", i);
-    streams_set_flag(i, ROAR_FLAG_SYNC);
-    if ( streams_sync_num )
-     return;
-   }
-  }
-
-  ROAR_INFO("streams_change_sync_num(id=%i, diff=%i): Can not auto set sync flag to an output. Very Bad",
-            ROAR_DBG_INFO_VERBOSE, id, diff
-            );
-  ROAR_WARN("streams_change_sync_num(id=%i, diff=%i): Lost all sync streams and failed to set a new one. Very Bad.",
-            id, diff);
- }
-}
 
 int streams_init (void) {
  int i;
-
- streams_rolestack = rolestack_get_role(-1); // get default
 
  for (i = 0; i < ROAR_STREAMS_MAX; i++)
@@ -152,19 +26,10 @@
 
 int streams_new    (void) {
- int i, j;
- struct roar_stream        * n = NULL;
- struct roar_stream_server * s = NULL;
-
-#ifdef ROAR_SUPPORT_LISTEN
- if ( g_terminate && !g_no_listen ) // don't accept new streams in case of termination state
-  return -1;
-#else
- if ( g_terminate )                 // don't accept new streams in case of termination state
-  return -1;
-#endif
+ int i;
+ struct roar_stream * n = NULL;
 
  for (i = 0; i < ROAR_STREAMS_MAX; i++) {
   if ( g_streams[i] == NULL ) {
-   s = ROAR_STREAM_SERVER(n = ROAR_STREAM(roar_mm_malloc(sizeof(struct roar_stream_server))));
+   n = malloc(sizeof(struct roar_stream_server));
    if ( n == NULL ) {
     ROAR_ERR("streams_new(void): can not allocate memory for new stream: %s", strerror(errno));
@@ -173,75 +38,18 @@
    }
 
-   memset(s, 0, sizeof(struct roar_stream_server));
-
    n->id         = i;
    n->fh         = -1;
-   n->pos_rel_id = -1;
-/*
+//   n->pos_rel_id = i;
    n->database   = NULL;
    n->dataoff    = NULL;
    n->datalen    = 0;
    n->offset     = 0;
-*/
-   n->pos        = 0;
-
-   s->name            = NULL;
-
-   s->state           = ROAR_STREAMSTATE_INITING;
-
-   s->client          = -1;
-   s->socktype        = ROAR_SOCKET_TYPE_UNKNOWN;
-   s->buffer          = NULL;
-   s->need_extra      =  0;
-   s->output          = NULL;
-   s->is_new          =  1;
-   s->codecfilter     = -1;
-   s->pre_underruns   =  0;
-   s->post_underruns  =  0;
-   s->delay           =  0;
-   s->codec_orgi      = -1;
-   s->primary         =  0;
-   s->ready           =  0;
-   s->outputbuffer    = NULL;
-   s->prethru         = NULL;
-   s->mixer_stream    = -1;
-   s->role            = ROAR_ROLE_UNKNOWN;
-   s->parent_stream   = -1;
-   s->single_sink_c   =  0;
-   s->single_sink_self_c =  0;
-
-   s->mixer.scale     = 65535;
-   s->mixer.rpg_mul   = 1;
-   s->mixer.rpg_div   = 1;
-   for (j = 0; j < ROAR_MAX_CHANNELS; j++)
-    s->mixer.mixer[j] = 65535;
-
-#ifdef ROAR_SUPPORT_META
-   for (j = 0; j < ROAR_META_MAX_PER_STREAM; j++) {
-    s->meta[j].type   = ROAR_META_TYPE_NONE;
-    s->meta[j].key[0] = 0;
-    s->meta[j].value  = NULL;
-   }
-#endif
-
-   roar_vio_clear_calls(&(s->vio));
-   roar_vio_clear_calls(&(s->jumbo));
-   s->viop      = &(s->vio);
-   s->driver_id = -1;
-   s->flags     =  ROAR_FLAG_NONE;
-
-#ifndef ROAR_WITHOUT_DCOMP_MIXER
-   s->mixerstream =  NULL;
-#endif
-
-   s->rpgmode = ROAR_RPGMODE_DEFAULT;
-
-   //roardsp_fchain_init(&(s->fc));
-
-   g_streams[i] = s;
-   counters_inc(streams, 1);
-   ROAR_INFO("streams_new(void): New stream %i created (state=initing)", ROAR_DBG_INFO_VERBOSE, i);
-   ROAR_DBG("streams_new(void): n->id=%i", n->id);
-   roar_notify_core_emit_snoargs(ROAR_OE_BASICS_NEW, -1, i, ROAR_OT_STREAM);
+
+   ((struct roar_stream_server*)n)->client     = -1;
+   ((struct roar_stream_server*)n)->buffer     = NULL;
+   ((struct roar_stream_server*)n)->need_extra = 0;
+   ((struct roar_stream_server*)n)->output     = NULL;
+
+   g_streams[i] = (struct roar_stream_server*)n;
    ROAR_DBG("streams_new(void) = %i", i);
    return i;
@@ -253,154 +61,27 @@
 
 int streams_delete (int id) {
- struct roar_stream_server * s;
- int prim;
- int no_vio_close = 0;
- int i;
- int client;
-
- _CHECK_SID(id);
-
- if ( (s = g_streams[id]) == NULL )
+ if ( g_streams[id] == NULL )
   return 0;
 
  ROAR_DBG("streams_delete(id=%i) = ?", id);
- ROAR_DBG("streams_delete(id=%i): g_streams[id]->id=%i", id, ROAR_STREAM(s)->id);
-
- // in case we are allready closing it...
- if ( s->state == ROAR_STREAMSTATE_CLOSING )
-  return 0;
-
- _streams_change_state(s, ROAR_STREAMSTATE_CLOSING, "streams_delete");
- roar_notify_core_emit_snoargs(ROAR_OE_BASICS_DELETE, -1, id, ROAR_OT_STREAM);
-
- streams_set_role(id, -1);
-
- prim = s->primary;
-
- if ( prim )
-  alive = 0;
-
- if ( s->flags & ROAR_FLAG_SINGLESINK )
-  streams_set_single_sink(id, 1);
-
- counters_inc(streams, -1);
-
- if ( streams_get_flag(id, ROAR_FLAG_RECSOURCE) == 1 )
-  streams_reset_flag(id, ROAR_FLAG_RECSOURCE);
-
- for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-  if ( g_streams[i] != NULL && ROAR_STREAM(g_streams[i])->pos_rel_id == id ) {
-   switch (ROAR_STREAM(g_streams[i])->dir) {
-    case ROAR_DIR_THRU:
-    case ROAR_DIR_RAW_IN:
-      if ( i != id )
-       streams_delete(i);
-     break;
-    default:
-      if ( streams_get_flag(i, ROAR_FLAG_VIRTUAL) == 1 ) {
-       if ( i != id ) {
-        ROAR_DBG("streams_delete(id=%i): Deleting virtual child stream %i", id, i);
-        streams_delete(i);
-       }
-      } else {
-       ROAR_STREAM(g_streams[i])->pos_rel_id = -1;
-      }
-   }
-  }
- }
-
- if ( ROAR_STREAM(s)->dir == ROAR_DIR_THRU )
-  streams_thru_num--;
-
- if ( streams_get_flag(id, ROAR_FLAG_VIRTUAL) == 1 ) {
-  // we un-group the stream here to avoid a client deleting the parent deleting the client deleting ...
-  i      = ROAR_STREAM(s)->pos_rel_id;
-  if ( i != -1 ) {
-   ROAR_STREAM(s)->pos_rel_id = -1;
-   client = streams_get_client(id);
-   streams_set_client(id, -1);
-   ROAR_DBG("streams_delete(id=%i): Stream has flag virtual, notifying parent stream %i", id, i);
-   streams_ctl(i, ROAR_CODECFILTER_CTL_VIRTUAL_DELETE|ROAR_STREAM_CTL_TYPE_INT, &id);
-   ROAR_DBG("streams_delete(id=%i): Notify send to stream %i", id, i);
-   streams_set_client(id, client);
-   ROAR_STREAM(s)->pos_rel_id = i;
-  }
- }
-
-#ifdef ROAR_SUPPORT_META
- // delete meta data form other meta streams if needed
- if ( streams_get_flag(id, ROAR_FLAG_META) == 1 ) {
-  ROAR_DBG("streams_delete(id=%i): deleting meta stream!", id);
-  stream_meta_clear(id);
-  stream_meta_finalize(id);
- }
-#endif
-
- if ( s->codecfilter != -1 ) {
-  codecfilter_close(s->codecfilter_inst, s->codecfilter);
-  s->codecfilter_inst = NULL;
-  s->codecfilter = -1;
- }
-
- if ( s->driver_id != -1 ) {
-  driver_closevio(&(s->vio), s->driver_id);
-  roar_vio_clear_calls(&(s->vio));
-  s->driver_id = -1;
-  no_vio_close =  1;
- }
-
-#ifndef ROAR_WITHOUT_DCOMP_MIXER
- if ( s->mixerstream != NULL ) {
-  hwmixer_close(id);
- }
-#endif
-
- // all IO is no disconnected:
- s->ready = 0;
-
- // re-try reset after all IO is disconnected.
- if ( streams_get_flag(id, ROAR_FLAG_RECSOURCE) == 1 )
-  streams_reset_flag(id, ROAR_FLAG_RECSOURCE);
-
- //roardsp_fchain_uninit(&(s->fc));
-
- if ( s->client != -1 ) {
+
+ if ( g_streams[id]->client != -1 ) {
   ROAR_DBG("streams_delete(id=%i): Stream is owned by client %i", id, g_streams[id]->client);
-  client_stream_delete(s->client, id);
- }
-
- stream_outputbuffer_destroy(id);
- stream_prethru_destroy(id);
-
- if ( s->buffer != NULL )
-  roar_buffer_free(s->buffer);
-
- if ( s->output != NULL )
-  roar_mm_free(s->output);
-
-/*
- if ( ROAR_STREAM(s)->fh != -1 )
-  close(ROAR_STREAM(s)->fh);
-*/
-
- if ( s->flags & ROAR_FLAG_SYNC )
-  streams_change_sync_num(id, -1);
-
- if ( !no_vio_close )
-  roar_vio_close(s->viop);
-
- if ( s->name != NULL )
-  roar_mm_free(s->name);
-
- roar_mm_free(s);
+  client_stream_delete(g_streams[id]->client, id);
+ }
+
+ if ( g_streams[id]->buffer != NULL )
+  roar_buffer_free(g_streams[id]->buffer);
+
+ if ( g_streams[id]->output != NULL )
+  free(g_streams[id]->output);
+
+ if ( ROAR_STREAM(g_streams[id])->fh != -1 )
+  close(ROAR_STREAM(g_streams[id])->fh);
+
+ free(g_streams[id]);
 
  g_streams[id] = NULL;
 
- if ( prim && alive ) {
-  alive = 0;
-  clean_quit();
- }
-
- ROAR_INFO("streams_delete(id=%i): stream deleted", ROAR_DBG_INFO_VERBOSE, id);
  ROAR_DBG("streams_delete(id=%i) = 0", id);
  return 0;
@@ -408,8 +89,7 @@
 
 int streams_set_client (int id, int client) {
-
- _CHECK_SID(id);
-
- ROAR_DBG("streams_set_client(id=%i): g_streams[id]->id=%i", id, ROAR_STREAM(g_streams[id])->id);
+ if ( g_streams[id] == NULL )
+  return -1;
+
  g_streams[id]->client = client;
 
@@ -417,521 +97,21 @@
 }
 
-int streams_get_client (int id) {
- _CHECK_SID(id);
-
- return g_streams[id]->client;
-}
-
-int streams_set_dir    (int id, int dir, int defaults) {
- struct roar_stream_server * ss;
- int mixer;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL ) {
-  ROAR_ERR("streams_set_dir(id=%i, dir=%i, defaults=%i) = -1 // error=NOENT", id, dir, defaults);
-  roar_err_set(ROAR_ERROR_NOENT);
-  return -1;
- }
-
- ROAR_STREAM(ss)->dir = dir;
-
- if ( dir == ROAR_DIR_THRU )
-  streams_thru_num++;
-
- if ( defaults ) {
-  if ( dir <= 0 || dir >= ROAR_DIR_DIRIDS ) {
-   ROAR_ERR("streams_set_dir(id=%i, dir=%i, defaults=%i) = -1 // error=INVAL", id, dir, defaults);
-   roar_err_set(ROAR_ERROR_INVAL);
-   return -1;
-  }
-
-  ROAR_DBG("streams_set_dir(*): g_config->streams[dir=%i].flags = 0x%.4x", dir, g_config->streams[dir].flags);
-
-  if ( streams_set_flag(id, g_config->streams[dir].flags) == -1 ) {
-   ROAR_WARN("streams_set_dir(*) = -1 // can not set stream flags");
-   return -1;
-  }
-
-   ss->mixer.scale   = g_config->streams[dir].mixer.scale;
-   ss->mixer.rpg_mul = g_config->streams[dir].mixer.rpg_mul;
-   ss->mixer.rpg_div = g_config->streams[dir].mixer.rpg_div;
- }
-
- if ( dir != ROAR_DIR_MIXING ) {
-  switch (streams_get_subsys(id)) {
-   case ROAR_SUBSYS_WAVEFORM:
-     streams_set_mixer_stream(id, g_waveform_mixer.stream);
-     roardsp_chanlist_init(ss->chanmap.in,  ROAR_STREAM(ss)->info.channels, ROARDSP_CHANLIST_MAP_ROARAUDIO);
-    break;
-#ifndef ROAR_WITHOUT_DCOMP_MIDI
-   case ROAR_SUBSYS_MIDI:
-     roardsp_chanlist_init(ss->chanmap.in,  ROAR_STREAM(ss)->info.channels, ROARDSP_CHANLIST_MAP_MIDI);
-     streams_set_mixer_stream(id, g_midi_mixer.stream);
-    break;
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_LIGHT
-   case ROAR_SUBSYS_LIGHT:
-     streams_set_mixer_stream(id, g_light_mixer.stream);
-    break;
-#endif
-  }
-
-  if ( streams_get_ssdir(id) & STREAM_DIR_OUT ) {
-   if ( (mixer = streams_get_mixer_stream(id)) != -1 ) {
-    if ( g_streams[mixer]->flags & ROAR_FLAG_SINGLESINK ) {
-     streams_set_mixer_stream(id, -1);
-     return -1;
-    }
-   }
-  }
-
-  memcpy(ss->chanmap.out, ss->chanmap.in, sizeof(ss->chanmap.out));
-  streams_set_map(id, NULL, 0);
+int streams_set_fh     (int id, int fh) {
+ if ( g_streams[id] == NULL )
+  return -1;
+
+ ((struct roar_stream *)g_streams[id])->fh = fh;
+
+ if ( ((struct roar_stream *)g_streams[id])->dir == ROAR_DIR_FILTER ) {
+  return 0;
  } else {
-  streams_set_mixer_stream(id, id);
- }
-
- ROAR_DBG("streams_set_dir(*) = 0");
- return 0;
-}
-
-int streams_get_dir    (int id) {
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- return ROAR_STREAM(ss)->dir;
-}
-
-int streams_set_mixer_stream(int id, int mixer) {
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- ss->mixer_stream = mixer;
-
- return 0;
-}
-
-int streams_get_mixer_stream(int id) {
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- return ss->mixer_stream;
-}
-
-static int streams_set_role_handle(int id) {
-   switch (streams_rolestack->action) {
-    case RS_ERROR: /* nothing to do */; break;
-    case RS_MIX:   /* nothing to do */; break;
-    case RS_KICK:  streams_delete(id);  break;
-    case RS_MUTE:  streams_set_flag(id, ROAR_FLAG_MUTE);  break;
-    case RS_PAUSE: streams_set_flag(id, ROAR_FLAG_PAUSE); break;
-   }
- return 0;
-}
-
-int streams_set_role   (int id, int role) {
- struct roar_stream_server * ss;
- const struct rolestack * rs;
- int old_role;
- int i;
-
- ROAR_DBG("streams_set_role(id=%i, role=%i) = ?", id, role);
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- old_role = ss->role;
- ss->role = role;
-
- ROAR_DBG("streams_set_role(id=%i, role=%i) = ?", id, role);
-
- if ( ROAR_STREAM(ss)->dir != ROAR_DIR_PLAY )
-  return 0;
-
- ROAR_DBG("streams_set_role(id=%i, role=%i) = ?", id, role);
-
- if ( old_role == role ) {
-  ROAR_DBG("streams_set_role(id=%i, role=%i) = 0", id, role);
-  return 0;
- }
-
- if ( old_role != role && old_role != -1 && role != -1 ) {
-  streams_set_role(id, -1);
-  streams_set_role(id, role);
- }
-
- ROAR_DBG("streams_set_role(id=%i, role=%i) = ?", id, role);
-
- if ( ss->role != -1 && ss->role == streams_rolestack->role ) {
-  ROAR_DBG("streams_set_role(id=%i, role=%i) = ?", id, role);
-
-  streams_role_num--;
-  if ( streams_role_num == 0 ) {
-   streams_rolestack = rolestack_get_role(-1); // get default
-   for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-    if ( (ss = g_streams[i]) == NULL )
-     continue;
-    if ( ROAR_STREAM(ss)->dir != ROAR_DIR_PLAY )
-     continue;
-    if ( ss->role == -1 )
-     continue;
-    rs = rolestack_get_role(ss->role);
-    if ( rs->index > streams_rolestack->role ) {
-     streams_rolestack = rs;
-    }
-   }
-   for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-    if ( (ss = g_streams[i]) == NULL )
-     continue;
-    if ( ROAR_STREAM(ss)->dir != ROAR_DIR_PLAY )
-     continue;
-    if ( ss->role == streams_rolestack->role )
-     streams_role_num++;
-   }
-  }
- } else if ( role != -1 ) {
-  ROAR_DBG("streams_set_role(id=%i, role=%i) = ?", id, role);
-
-  rs = rolestack_get_role(role);
-  ROAR_DBG("streams_set_role(id=%i, role=%i): rs->index=%i, streams_rolestack->index=%i", id, role, rs->index, streams_rolestack->index);
-  if ( rs->index == streams_rolestack->index ) {
-   ROAR_DBG("streams_set_role(id=%i, role=%i): rs->index=%i, streams_rolestack->index=%i", id, role, rs->index, streams_rolestack->index);
-   streams_role_num++;
-  } else if ( rs->index > streams_rolestack->index ) {
-   ROAR_DBG("streams_set_role(id=%i, role=%i): rs=%p{.index=%i, .action=%s}", id, role, rs, rs->index, rolestack_action2str(rs->action));
-   streams_role_num  = 1;
-   streams_rolestack = rs;
-   for (i = 0; i < ROAR_STREAMS_MAX; i++) {
-    if ( (ss = g_streams[i]) == NULL )
-     continue;
-    if ( ROAR_STREAM(ss)->dir != ROAR_DIR_PLAY )
-     continue;
-    rs = rolestack_get_role(ss->role);
-    ROAR_DBG("streams_set_role(id=%i, role=%i): i=%i, rs->index=%i, streams_rolestack->index=%i", id, role, i, rs->index, streams_rolestack->index);
-    if ( rs->index < streams_rolestack->index )
-     streams_set_role_handle(i);
-   }
-  } else {
-   ROAR_DBG("streams_set_role(id=%i, role=%i): streams_rolestack->action=%s", id, role, rolestack_action2str(streams_rolestack->action));
-   streams_set_role_handle(id);
-  }
- }
-
- ROAR_DBG("streams_set_role(id=%i, role=%i) = 0", id, role);
- return 0;
-}
-
-int streams_get_subsys (int id) {
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- if ( ROAR_STREAM(ss)->dir == ROAR_DIR_THRU )
-  return streams_get_subsys(ROAR_STREAM(ss)->pos_rel_id);
-
- return streams_dir2subsys(ROAR_STREAM(ss)->dir);
-}
-
-int streams_dir2subsys (int dir) {
- switch (dir) {
-  case ROAR_DIR_PLAY:
-  case ROAR_DIR_RECORD:
-  case ROAR_DIR_MONITOR:
-  case ROAR_DIR_FILTER:
-  case ROAR_DIR_OUTPUT:
-  case ROAR_DIR_BIDIR:
-  case ROAR_DIR_RECPLAY:
-    return ROAR_SUBSYS_WAVEFORM;
-   break;
-  case ROAR_DIR_MIDI_IN:
-  case ROAR_DIR_MIDI_OUT:
-    return ROAR_SUBSYS_MIDI;
-   break;
-  case ROAR_DIR_LIGHT_IN:
-  case ROAR_DIR_LIGHT_OUT:
-    return ROAR_SUBSYS_LIGHT;
-   break;
-  case ROAR_DIR_RAW_IN:
-  case ROAR_DIR_RAW_OUT:
-    return ROAR_SUBSYS_RAW;
-   break;
-  case ROAR_DIR_COMPLEX_IN:
-  case ROAR_DIR_COMPLEX_OUT:
-    return ROAR_SUBSYS_COMPLEX;
-   break;
-  case ROAR_DIR_MIXING:
-    return ROAR_SUBSYS_NONE;
-   break;
- }
-
- return -1;
-}
-
-int streams_get_ssdir  (int id) {
- struct roar_stream_server * ss;
-
- _CHECK_SID(id);
-
- if ( (ss = g_streams[id]) == NULL )
-  return -1;
-
- switch (ROAR_STREAM(ss)->dir) {
-  case ROAR_DIR_PLAY:
-  case ROAR_DIR_MIDI_IN:
-  case ROAR_DIR_LIGHT_IN:
-  case ROAR_DIR_RAW_IN:
-  case ROAR_DIR_COMPLEX_IN:
-    return STREAM_DIR_IN;
-   break;
-  case ROAR_DIR_RECORD:
-  case ROAR_DIR_MONITOR:
-  case ROAR_DIR_OUTPUT:
-  case ROAR_DIR_MIDI_OUT:
-  case ROAR_DIR_LIGHT_OUT:
-  case ROAR_DIR_RAW_OUT:
-  case ROAR_DIR_COMPLEX_OUT:
-    return STREAM_DIR_OUT;
-   break;
-  case ROAR_DIR_MIXING:
-    return STREAM_DIR_NONE;
-   break;
-  case ROAR_DIR_FILTER:
-  case ROAR_DIR_BIDIR:
-  case ROAR_DIR_RECPLAY:
-    return STREAM_DIR_BIDIR;
-   break;
-  case ROAR_DIR_THRU:
-    return streams_get_ssdir(ROAR_STREAM(ss)->pos_rel_id);
-   break;
- }
-
- return -1;
-}
-
-#define _err() streams_delete(id); return -1;
-int streams_new_virtual (int parent, struct roar_stream_server ** stream) {
- struct roar_stream_server * parent_ss, * ss;
- struct roar_stream        * parent_s , *  s;
- int id = -1;
- int client, dir;
-
- if ( streams_get(parent, &parent_ss) == -1 )
-  return -1;
-
- if ( (client = streams_get_client(parent)) == -1 )
-  return -1;
-
- if ( (dir = streams_get_dir(parent)) == -1 )
-  return -1;
-
- if ( (id = streams_new()) == -1 ) {
-  return -1;
- }
-
- if ( client_stream_add(client, id) == -1 ) {
-  _err();
- }
-
- if ( streams_get(id, &ss) == -1 ) {
-  _err();
- }
-
- if ( streams_set_dir(id, dir, 1) == -1 ) {
-  _err();
- }
-
- s        = ROAR_STREAM(       ss);
- parent_s = ROAR_STREAM(parent_ss);
-
- s->pos_rel_id = parent;
-
- if ( streams_set_rawflag(id, ROAR_FLAG_VIRTUAL) == -1 ) {
-  _err();
- }
-
- if ( stream != NULL )
-  *stream = ss;
-
- return id;
-}
-#undef _err
-
-int streams_set_fh     (int id, int fh) {
- struct roar_stream_server * ss;
- struct roar_stream        * s;
- int dir;
- int nonblock = 1;
-
- _CHECK_SID(id);
-
- if ( (s = ROAR_STREAM(ss = g_streams[id])) == NULL )
-  return -1;
-
- if ( ss->ready && !(s->fh == -1 && fh == -2) ) {
-  ROAR_DBG("streams_set_fh(id=%i, fh=%i) = -1 // try to set fh for stream which is already ready", id, fh);
-  return -1;
- }
-
- dir = s->dir;
-
- ROAR_DBG("streams_set_fh(id=%i, fh=%i): g_streams[id]->id=%i", id, fh, s->id);
-
- s->fh = fh;
-
- ROAR_DBG("streams_set_fh(id=%i, fh=%i): driverID=%i", id, fh, ss->driver_id);
-
- if ( ss->driver_id == -1 && fh != -2 ) {
-#ifndef ROAR_TARGET_WIN32
-  roar_vio_open_fh(&(ss->vio), fh);
-#else
-  roar_vio_open_fh_socket(&(ss->vio), fh);
-#endif
- }
-
- ROAR_DBG("streams_set_fh(id=%i, fh=%i) = ?", id, fh);
-
- switch (dir) {
-  case ROAR_DIR_THRU:
-  case ROAR_DIR_RAW_IN:
-  case ROAR_DIR_RAW_OUT:
-   break;
-  default:
-    ROAR_DBG("streams_set_fh(id=%i, fh=%i): codec=%s(%i)", id, fh, roar_codec2str(s->info.codec), s->info.codec);
-    if ( codecfilter_open(&(ss->codecfilter_inst), &(ss->codecfilter), NULL,
-                     s->info.codec, ss) == -1 ) {
-     streams_delete(id); // TODO: FIXME: is this correct? shoudn't we return -1 in any case here?
-     ROAR_DBG("streams_set_fh(id=%i, fh=%i) = -1", id, fh);
-     return -1;
-    }
-   break;
- }
-
- ROAR_DBG("streams_set_fh(id=%i, fh=%i) = ?", id, fh);
-
- if ( fh == -2 ) {
-  ROAR_DBG("streams_set_fh(id=%i, fh=%i) = ?", id, fh);
-  if ( roar_vio_ctl(&(ss->vio), ROAR_VIO_CTL_GET_READ_FH, &fh) == -1 ) {
-   fh = -2;
-  } else {
-   ROAR_DBG("streams_set_fh(id=%i, fh=%i) = ?", id, fh);
-   if ( fh < 0 ) {
-    fh = -2;
-   } else {
-    s->fh = fh;
-   }
-  }
- }
-
- ROAR_DBG("streams_set_fh(id=%i, fh=%i) = ?", id, fh);
-
- if ( fh == -1 || fh == -2 ) { // yes, this is valid, indecats full vio!
-  ss->ready = 1;
-  //ROAR_INFO("streams_set_fh(id=%i, fh=%i): stream state: %s->new", ROAR_DBG_INFO_VERBOSE, id, fh, roar_streamstate2str(ss->state));
-  _streams_change_state(ss, ROAR_STREAMSTATE_NEW, "streams_set_fh");
-  ROAR_DBG("streams_set_fh(id=%i, fh=%i): s->fh=%i", id, fh, s->fh);
-  ROAR_DBG("streams_set_fh(id=%i, fh=%i) = 0", id, fh);
-  return 0;
- }
-
- ROAR_DBG("streams_set_fh(id=%i, fh=%i) = ?", id, fh);
-
- switch (dir) {
-  case ROAR_DIR_MONITOR:
-  case ROAR_DIR_RECORD:
-  case ROAR_DIR_OUTPUT:
-  case ROAR_DIR_MIDI_OUT:
-  case ROAR_DIR_LIGHT_OUT:
-  case ROAR_DIR_RAW_OUT:
-    ROAR_SHUTDOWN(fh, SHUT_RD);
-   break;
- }
-
- if ( dir >= ROAR_DIR_DIRIDS )
-  return -1;
-
- if ( g_config->streams[dir].flags & ROAR_FLAG_SYNC ) {
-  switch (dir) {
-   case ROAR_DIR_BRIDGE:
-   case ROAR_DIR_MIDI_OUT:
-    break;
-   default:
-     nonblock = 0;
-    break;
-  }
- }
-
-
- if ( !nonblock ) {
-  ss->ready = 1;
-  //ROAR_INFO("streams_set_fh(id=%i, fh=%i): stream state: %s->new", ROAR_DBG_INFO_VERBOSE, id, fh, roar_streamstate2str(ss->state));
-  _streams_change_state(ss, ROAR_STREAMSTATE_NEW, "streams_set_fh");
-
-  ROAR_DBG("streams_set_fh(id=%i, fh=%i) = 0", id, fh);
-  return 0;
- } else {
-#ifndef ROAR_TARGET_WIN32
-  if ( roar_socket_nonblock(fh, ROAR_SOCKET_NONBLOCK) == -1 )
-   return -1;
-#endif
-
-  ss->ready = 1;
-  //ROAR_INFO("streams_set_fh(id=%i, fh=%i): stream state: %s->new", ROAR_DBG_INFO_VERBOSE, id, fh, roar_streamstate2str(ss->state));
-  _streams_change_state(ss, ROAR_STREAMSTATE_NEW, "streams_set_fh");
-
-  ROAR_DBG("streams_set_fh(id=%i, fh=%i) = 0", id, fh);
-  return 0;
- }
-}
-
-int streams_get_fh     (int id) {
- int ret;
-
- ROAR_DBG("streams_get_fh(id=%i) = ?", id);
-
- _CHECK_SID(id);
-
- ROAR_DBG("streams_get_fh(id=%i) = ?", id);
-
- ret = ROAR_STREAM(g_streams[id])->fh;
-
- ROAR_DBG("streams_get_fh(id=%i) = %i", id, ret);
-
- return ret;
-}
-
-int streams_set_null_io(int id) {
- struct roar_stream_server * ss;
- struct roar_stream        * s;
-
- _CHECK_SID(id);
-
- if ( (s = ROAR_STREAM(ss = g_streams[id])) == NULL )
-  return -1;
-
- s->fh = -1;
-
- return 0;
-}
+  return roar_socket_nonblock(fh, ROAR_SOCKET_NONBLOCK);
+ }
+}
+
 
 int streams_get    (int id, struct roar_stream_server ** stream) {
- _CHECK_SID(id);
+ if ( g_streams[id] == NULL )
+  return -1;
 
  *stream = g_streams[id];
